#!/bin/bash

ICP_SRIOV_AM=
QAT_4XXX_NUM_VFS=16
#Device information variables
INTEL_VENDORID="8086"
QAT_4XXX_DEVICE_NUMBER="4940"
QAT_4XXX_DEVICE_NUMBER_VM="4941"
QAT_401XX_DEVICE_NUMBER="4942"
QAT_401XX_DEVICE_NUMBER_VM="4943"
VQAT_DEVICE_NUMBER="0da5"

num4xxxDevice=`lspci -vnd 8086: | egrep -c "4940|4941|4942|4943"`
num4xxxDevicesP=`lspci -n | egrep -c "$INTEL_VENDORID:($QAT_4XXX_DEVICE_NUMBER|$QAT_401XX_DEVICE_NUMBER)"`
num4xxxDevicesV=`lspci -n | egrep -c "$INTEL_VENDORID:($QAT_4XXX_DEVICE_NUMBER_VM|$QAT_401XX_DEVICE_NUMBER_VM)"`
numVQATDevices=`lspci -vnd 8086: | egrep -c "$INTEL_VENDORID:$VQAT_DEVICE_NUMBER"`

if [ "$ICP_SRIOV_AM" != "2" ]; then                                       
	if [ "$num4xxxDevicesP" -gt "0" ]; then                                   
    	sh /tmp/qat/generate_conf_files.sh -n $num4xxxDevicesP -f /tmp/qat/4xxx_template.conf -o /tmp/qat/
	fi											
	for (( dev=0; dev<$num4xxxDevicesP; dev++ ))                              
    do                                                  	
		install -D -m 640 /tmp/qat/4xxx_dev$dev.conf /etc/4xxx_dev$dev.conf 
	done                                                   
fi									
if [ "$ICP_SRIOV_AM" == "1" ]; then                             
	for (( dev=0; dev<$num4xxxDevicesP; dev++ ))               
    do                                                      
    	for (( vf_dev = 0; vf_dev<$QAT_4XXX_NUM_VFS; vf_dev++ ))   
        do                                                     
       		vf_dev_num=$[$dev * $QAT_4XXX_NUM_VFS + $vf_dev]     
            install -D -m 640 /tmp/qat/4xxxvf_dev0.conf.vm /etc/4xxxvf_dev$vf_dev_num.conf
        done
	done
else   
	for (( dev=0; dev<$num4xxxDevicesV; dev++ ))  
	do		
		install -D -m 640 /tmp/qat/4xxxvf_dev0.conf.vm /etc/4xxxvf_dev$dev.conf
	done;                                                                     
	if [ $numVQATDevices != 0 ]; then  
    	sh /tmp/qat/config_vqat.sh    
	fi						
fi 
